#ifndef _h_FASTIO_
#define _h_FASTIO_

#include <fcntl.h>
#include <sys/stat.h>
#ifndef _h_TYPES_
# include <cv/types.h>
#endif


struct FastFile{
	int handle;
	static int error;

	FastFile()		:handle(-1) {}
	~FastFile()		{ close(); }
	int	clearerr()	{ int err = error; error = 0; return err; }

	bool SMALL_	open(CStr, count flags, count share = O_DENYNONE);
	bool SMALL_	create(CStr, count permission = S_IREAD | S_IWRITE);
	size_t FAST_	read(void*, size_t);
	size_t FAST_	write(CVP, size_t);
	bool SMALL_	close();
};

#endif /* _h_FASTIO_ */
