#include "libdef.inc"
#if !defined(STD_CODE) && defined(ASM86_CODE)
# include <cv/asm86.h>
#endif
#include <cv/string2.h>

/* "Check for stack overflow" off for BC++ 3.1 */
#pragma option -N-

#pragma argsused

void *SMALL_ memcopy(void *dest, CVP src, size_t sz){
#if defined(STD_CODE) || !defined(ASM86_CODE)

#pragma intrinsic memcpy

	if(src == NULL || dest == NULL) return NULL;
	memcpy(dest, src, sz); 
	return (byte*)dest + sz;
#else
	I cld; _CX = sz; _CLR(_DX);
#  ifdef FARDATA
	_BX = _DS; I LDS_ si, DPTR_(src); _AX = _DS; _AX |= _SI;
#  else
	_SI = FP_OFF(src); _AX = _SI; _AX |= _AX;
#  endif
	if(!isFLAG(Zero)){
#  ifdef FARDATA
		I LES_ di, DPTR_(dest); _AX = _ES; _AX |= _DI;
#  else
		_DI = FP_OFF(dest); _ES = _AX = _DS; _AX = _DI; _AX |= _AX;
#  endif
		if(!isFLAG(Zero)){
			if(odd(_DI) && _CX) { I movsb; _CX--; }
			_CX >>= 1; I rep movsw;
			I adc cx, cx; I rep movsb;
			_AX = _DI;
#  ifdef FARDATA
			_DX = _ES;
#  endif
	}	}
#  ifdef FARDATA
	_DS = _BX;
	return (void*)MAKE_ULONG;
#  else
	return (void*)_AX;
#  endif
#endif
}
