#include "libdef.inc"
#include <cv/asm86.h>
#include <cv/string2.h>

/* "Check for stack overflow" off for BC++ 3.1 */
#pragma option -N-

/*----------------------------------------------------------------------*/
/*   砫 ப ᥣ, 饣 ⮫쪮   .*/
/* 頥   ᥣ				*/

#pragma argsused

size_t FAST_ memspan(CVP s, size_t sz, char ch){
#if defined(STD_CODE) || !defined(ASM86_CODE)

#  ifdef FARDATA
#	define sp (*(const char**)&s)
#  else
	PCStr sp = (const char*)s;
#  endif
	if(sp == NULL) sz = 0;
	count len = 0;
	for(ch = ch; len < sz; len++) { if(*sp != ch) break; sp++; }
	return len;
#else
	_CX = _AX /*sz*/;
#  ifdef FARDATA
	I LES_ di, DPTR_(s); _AX = _ES; _AX |= _DI;
#	define TEMP	_BX
#  else
	_DI = FP_OFF(s); _ES = _AX = FP_SEG(s); _AX = _DI; _AX |= _AX;
#	define TEMP	_SI
#  endif
	if(!isFLAG(Zero)){
		_AL = ch; TEMP = _CX;
		_CX |= _CX; /* !!! ⠭ 䫠 Zero, ᫨ _CX == 0 */
		I repe scasb; _AX = TEMP;
		if(!isFLAG(Equal)) { _AX -= _CX; _AX--; }
	}
	return _AX;
#endif
}
